program plutil2;
uses	crt;
(*
  Skadnia: plutil2 komenda standard(y) plikwe plikwy

  Komendy: K - zamiana standardu polskich znakw
	   KD- zamiana polskich znakw na znaki download,
	   T - zamiana polskie znaki <=> komendy TeX-a,
	   S - dodanie znakw sterujcych dla drukarki,
	   SD- znaki sterujce + download.

  Standardy : (M)azovia, (L)atin-2, (W)indows, (D)HN, (C)SK,
	      C(Y)fromat, M(I)crovex, IS(O) Latin-2, I(E)A,
	      Lo(G)ic, (V)entura, IINTE-I(S)IS, ELWRO (J)unior,
	      Macintos(H), Amiga (P)L, Te(X) PL, Atari-Calam(U)s,
	      Corel D(R)aw!, (A)TM, (B)ez polskich znakw.

  Standardy TeX :   (T)eX, TeX I(F)J.

  W przypadku komend K i T podawa 2 standardy (np. dla K "ml" oznacza zamian
  z Mazovii na Latin II, dla T "mt" oznacza zamian z Mazovii na TeX).

  Dla komend KD i SD podac tylko 1 standard (standard pliku WE, np. "M"
  w przypadku Mazovii).

  Dla komendy S nie podawac standardu.


  Przykady :

  plutil2 k mw plik1.txt plik2.txt => zamiana standardu z Mazovii na Windows

  PLUTIL2 k bd plik1.txt plik2.txt => moliwe, ale bez sensu: zamiana wszystkich
				     a, e itd. na "ogonki" w standardzie DHN
  plutil2 kd m plik.txt prn	  => drukowanie pliku w standardzie Mazovia
				     na drukarce typu EPSON FX bez wbudowanych
				     polskich znakw
  plutil2 T LT PLIK.TXT PLIK.TEX   => zamiana "ogonkw" w standardzie Latin II
				     na komendy TeX-a
  plutil2 t tl plik.tex plik.txt   => operacja odwrotna

  plutil2 S plik.txt plik.bin	  => zamiana kodw sterujcych programu
				     na kody sterujce drukarki
  plutil2 SD w plik.txt plik.bin   => jw. lecz z zamian polskich znakw w
				     standardzie Windows na znaki download.


	KODY STERUJCE PROGRAMU (stosowane przy komendach S i SD) :

\b	Backspace	znak w ty

\F	Form Feed	koniec strony

\w	Double Width	podwjna szeroko
			(w ramach 1 linii)

\Cw			powrt do trybu
			zwykego

\c	Condensed	tryb zagszczony

\Cc			powrt

\Onnn			dodatkowy odstp miedzy znakami
			rwny nnn kropek (np. O009 => 9 kropek)

\U	Underline	znaki podkrelone

\CU			powrt

\I	Italic		znaki pochylone
			(kursywa)

\CI			powrt

\E	Emphasized	znaki pogrubione

\CE			powrt

\B	Double Strike	znaki drukowane
			podwjnie

\CB			powrt

\e	Elite		tryb 12 zn/cal

\p	Pica		tryb 10 zn/cal

\W	Double Width	podwjna szeroko

\CW			powrt

\P	Proportional	znaki proporcjonalne

\CP			powrt

\H	Double Height	podwjna wysoko

\CH			powrt

\^			znak "^"

\_			znak "_"

\\			znak "\"

\$			znak "" (uwaga, na niektrych drukarkach moe wyj
			co innego)

^...^	Superscript	indeks grny

_..._	Subscript	indeks dolny


	Przykady zastosowania kodw sterujcych programu :

G^i^_j_ 		-	znak "G" z indeksem grnym "i" i nieco z przodu
				dolnym "j"

G^i^\b_j_		-	jw., lecz indeksy grny i dolny maj t sam
				pozycj w poziomie

jest \Bbardzo\CB	-	sowo "bardzo" jest drukowane podwjnie

\w\HDawno\CH temu	-	sowo "Dawno" jest drukowane w trybie podwjnej
				wysokoci i szerokoci, "temu" w trybie podwj-
				nej szerokoci

Program powinien dobrze dziaa dla drukarek typu Epson FX lub IBM Graphics
Printer; dla IBM Proprinter oraz dla drukarek 24-igowych nie bdzie dziaa
tryb download oraz (by moe) niektre komendy.

*)

type	tafnt=array[1..20,1..18] of char;
	arrcmd=array[1..18] of string[5];

const	polskie : tafnt =
	('',
	 '䢘',
	 '󜿟ʣӌ',
	 '',
	 '',
	 '',
	 '',
	 '󶿼ʣӦ',
	 '뒝',
	 '',
	 '',
	 '',
	 '',
	 'ė',
	 '',
	 '󱻹ӑ',
	 '',
	 '󥺪ɣ',
	 '',
	 'acelnoszzACELNOSZZ');
	stand : string[20] = 'MLWDCYIOEGVSJHPXURAB';

download : string[221]=
	#$1B#$26#$00#$21#$32+ {Esc & nul pocz koniec}
	#$0A#$08#$14#$40#$14#$40#$14#$42#$39#$04#$01#$00+ {}
	#$88#$1C#$22#$00#$22#$40#$A2#$00#$22#$00#$00#$00+ {}
	#$09#$38#$44#$10#$44#$10#$46#$11#$44#$31#$00#$00+ {}
	#$87#$00#$00#$8A#$00#$FE#$00#$22#$00#$00#$00#$00+ {}
	#$88#$20#$1E#$20#$00#$60#$80#$20#$1E#$00#$00#$00+ {}
	#$89#$1C#$22#$00#$22#$40#$A2#$00#$22#$1C#$00#$00+ {}
	#$89#$10#$2A#$00#$2A#$40#$AA#$00#$2A#$04#$00#$00+ {}
	#$87#$22#$04#$22#$88#$22#$10#$22#$00#$00#$00#$00+ {}
	#$87#$22#$04#$22#$48#$A2#$10#$22#$00#$00#$00#$00+ {}
	#$87#$1E#$20#$48#$80#$48#$22#$1D#$00#$00#$00#$00+ {}
	#$87#$3C#$42#$20#$42#$80#$42#$24#$00#$00#$00#$00+ {}
	#$88#$FE#$00#$92#$00#$92#$00#$83#$01#$00#$00#$00+ {}
	#$89#$FE#$00#$12#$00#$22#$00#$42#$00#$02#$00#$00+ {}
	#$88#$7E#$00#$20#$50#$08#$84#$00#$7E#$00#$00#$00+ {}
	#$87#$3C#$42#$20#$42#$80#$42#$3C#$00#$00#$00#$00+ {}
	#$87#$24#$52#$00#$6A#$00#$CA#$24#$00#$00#$00#$00+ {}
	#$87#$42#$04#$4A#$80#$52#$20#$42#$00#$00#$00#$00+ {}
	#$87#$42#$04#$6A#$00#$D2#$20#$42#$00#$00#$00#$00; {}

     robdown : string[3]=#27'%'#1;
     robnorm : string[3]=#27'%'#0;

komtex : arrcmd =
	('\c{a}','\''{c}','\c{e}','\l{}','\''{n}','\''{o}','\''{s}','\.{z}','\''{z}',
	 '\c{A}','\''{C}','\c{E}','\L{}','\''{N}','\''{O}','\''{S}','\.{Z}','\''{Z}');
komifj : arrcmd =
	('\,{a}','\''{c}','\,{e}','\l{}','\''{n}','\''{o}','\''{s}','\.{z}','\''{z}',
	 '\,{A}','\''{C}','\,{E}','\L{}','\''{N}','\''{O}','\''{S}','\.{Z}','\''{Z}');

     litwe : string[17] = 'FbwcUIEBepWPH^_\$'; { litery dla kodw po "\" }
     litwy : string[9] = 'wcUIEBWPH'; { litery kodw powrotnych po "\C" }

komwe : array[1..17] of string[3]=
	(#12,#8,#14,#15,#27#45#1,#27#52,#27#69,#27#71,#27#77,#27#80,#27#87#1,
	 #27#112#1,#27#119#1,'^','_','\',#21); { cigi sterujce dla kodw }
komwy : array[1..9] of string[3]=
	(#20,#18,#27#45#0,#27#53,#27#70,#27#72,#27#87#0,#27#112#0,#27#119#0);
	{ cigi sterujce dla kodw powrotnych }

     zngraf : string[2]=#27#54; { rozszerzony zbir znakw }
     indgor : string[3]=#27#83#0; { indeksy grne }
     inddol : string[3]=#27#83#1; { indeksy dolne }
     zakind : string[2]=#27#84; { koniec ind. grnych/dolnych }
     odstep : string[2]=#27#32; { odstp midzy znakami - Esc ' ' nn }

var	bufor:array[0..255] of char; cg1,cg2,cg3,cg4:string;
	plikwe,plikwy:text; ch:char; k,l,n:longint;
	komenda,zak:boolean; tacmd:arrcmd; bufwe,bufwy:array[1..20480] of byte;

function upper(cg:string):string;
var	 k:longint; cg1:string;
begin
 cg1:=cg;
 for k:=1 to length(cg1) do cg1[k]:=upcase(cg1[k]);
 upper:=cg1;
end;

procedure zlyplik(nazwa:string);
begin
 write(#7'Nie moge otworzyc pliku ',nazwa,' !');
 halt;
end;

function czyjest(zn:char; pytciag:string; var numer:longint):boolean;
begin
 numer:=pos(zn,pytciag);
 if numer=0 then czyjest:=false else czyjest:=true;
end;

function czystd(std:char; var numer:longint):boolean;
begin
 czystd:=czyjest(std,stand,numer);
end;

procedure ustaw(stdwe,stdwy:char);
var	  l1,l2,l3:longint;
begin
 czystd(stdwe,l1);
 czystd(stdwy,l2);
 for l3:=0 to 255 do bufor[l3]:=char(l3);
 for l3:=1 to 18 do bufor[ord(polskie[l1,l3])]:=polskie[l2,l3];
end;

function czypl(zn,std:char; var numer:longint):boolean;
var	 l1:longint;
begin
 czystd(std,l1);
 numer:=pos(zn,polskie[l1]);
 if numer=0 then czypl:=false else czypl:=true;
end;

procedure piszcg(cg:string);
begin
 for l:=1 to ord(cg[0]) do write(plikwy,cg[l]);
end;

procedure sprcmd(tabl:arrcmd);
begin
 k:=2;
 cg4:='\';
 zak:=false;
 repeat
  komenda:=false;
  read(plikwe,ch);
  for l:=1 to 18 do if ch=tabl[l,k] then komenda:=true;
  cg4:=cg4+ch;
  inc(k);
  for l:=1 to 18 do if cg4=tabl[l] then
  begin
   zak:=true;
   k:=l;
  end;
 until ((zak=true) or (komenda=false) or (k=6));
 if (not zak) then
 begin
  k:=0;
  piszcg(cg4);
 end;
end;

procedure pisztab(nr:byte; ciag:string);
begin
 gotoxy(nr shl 3 + 1,wherey);
 writeln(ciag);
end;

procedure blad;
begin
 pisztab(1,'Program PLUTIL for OS/2 wersja 1.02. Autor: Sawomir Stachniewicz.');
 pisztab(1,'Skadnia : PLUTIL2 komenda standard(y) plik1 plik2.');
 writeln;
 pisztab(1,'Komendy: K - zamiana standardu polskich liter,');
 pisztab(2,' KD- zamiana polskich znakw na znaki download,');
 pisztab(2,' T - zamiana polskie znaki <=> komendy TeX-a,');
 pisztab(2,' S - dodanie znakw sterujcych dla drukarki,');
 pisztab(2,' SD- znaki sterujce + download.');
 writeln;
 pisztab(1,'Standardy :     (M)azovia, (L)atin II, (W)indows, (D)HN, (C)SK,');
 pisztab(3,'C(Y)fromat, M(I)crovex, IS(O) Latin II, I(E)A,');
 pisztab(3,'Lo(G)ic, (V)entura, IINTE-I(S)IS, ELWRO (J)unior,');
 pisztab(3,'Macintos(H), Amiga (P)L, Te(X) PL, Atari-Calam(U)s,');
 pisztab(3,'Corel D(R)aw!, (A)TM, (B)ez polskich znakw.');
 writeln;
 pisztab(1,'Standardy TeX : (T)eX, TeX I(F)J.');
 writeln;
 pisztab(1,'W przypadku komend K i T podawa 2 standardy');
 pisztab(1,'(np. "ml" - z Mazovii na Latin II).');
 pisztab(1,'Dla komend KD i SD poda tylko 1 standard.');
 pisztab(1,'Dla komendy S nie podawa standardu.');
 halt(1);
end;

begin
 if paramcount>0 then cg1:=upper(paramstr(1));
 if not (((paramcount=3) and (cg1='S')) or (paramcount=4)) then blad;
 cg2:=upper(paramstr(2));
 if cg1='S' then
 begin
  cg3:=paramstr(2);
  cg4:=paramstr(3);
 end else begin
  cg3:=paramstr(3);
  cg4:=paramstr(4);
 end;
 if not czyjest(cg1[1],'KTS',n) then blad;
 assign(plikwe,cg3);
 assign(plikwy,cg4);
 settextbuf(plikwe,bufwe);
 settextbuf(plikwy,bufwy);
{ due bufory dla operacji WE/WY }
 filemode:=0;
 reset(plikwe);
 if ioresult<>0 then zlyplik(paramstr(3));
 rewrite(plikwy);
 if ioresult<>0 then zlyplik(paramstr(4));
{ jeli nie mona otworzy plikw to protest }

 if cg1='KD' then { zam. standardw + download }
 begin
  piszcg(download);
  repeat
   read(plikwe,ch);
   if czypl(ch,cg2[1],n) then
{ zastpowanie polskich znakw znakami download - przejcie w tryb d.,
  wydrukowanie znaku, wyjcie z trybu d. }
   begin
    ch:=char(n+32);
{ arbitralnie wybrane znaki o kodach od 33 do 50 }
    piszcg(robdown);
    write(plikwy,ch);
    piszcg(robnorm);
   end else write(plikwy,ch);
  until eof(plikwe);
 end;

 if cg1='K' then { zamiana standardw kodowania PL liter, 1:1 }
 begin
  if ((ord(cg2[0])<2) or (not czystd(cg2[2],n))) then blad;
  ustaw(cg2[1],cg2[2]);
  repeat
   read(plikwe,ch);
   write(plikwy,bufor[ord(ch)]);
  until eof(plikwe);
 end;

 if cg1='T' then { PL=>TeX lub TeX=> PL }
 begin
  if (czyjest(cg2[1],'TF',n) and czystd(cg2[2],n)) then
  begin
   repeat
    read(plikwe,ch);
    if ch<>'\' then write(plikwy,ch) else
    begin
     if cg2[1]='T' then tacmd:=komtex else tacmd:=komifj;
     sprcmd(tacmd);
     if k<>0 then
     begin
      l:=pos(cg2[2],stand);
      write(plikwy,polskie[l,k]);
     end;
    end;
   until eof(plikwe);
  end else if (czyjest(cg2[2],'TF',n) and czystd(cg2[1],n)) then
  begin
   repeat
    read(plikwe,ch);
    if czypl(ch,cg2[1],n) then
    begin
     if cg2[2]='T' then cg4:=komtex[n] else cg4:=komifj[n];
     piszcg(cg4);
    end else write(plikwy,ch);
   until eof(plikwe);
  end;
 end;

 if cg1[1]='S' then
{ z uyciem kodw dla drukarki }
 begin
  if cg1='SD' then piszcg(download); { dodatkowo download }
  piszcg(zngraf);
  komenda:=false; { komenda=TRUE => jeli tryb indeksw grn. lub dln. }
  repeat
   read(plikwe,ch);
   if ((cg1='SD') and czypl(ch,cg2[1],n)) then
{ jeli download to zastpi polskie znaki }
   begin
    ch:=char(n+32);
    piszcg(robdown);
    write(plikwy,ch);
    piszcg(robnorm);
   end else begin
    if czyjest(ch,'^_',n) then { czy indeks grn. lub dln. }
    begin
     if komenda then
     begin
      piszcg(zakind);
      komenda:=false; { koniec ind. grnych/dolnych }
     end else begin
      if ch='^' then piszcg(indgor) else piszcg(inddol);
      komenda:=true; { indeks grny lub dolny }
     end;
    end;
    if ch<>'\' then write(plikwy,ch) else
    begin
{ jeli "\" to prawdopodobnie kod dla drukarki }
     read(plikwe,ch);
     k:=pos(ch,litwe); { k<>0 => jest to komenda nr k }
     if k<>0 then piszcg(komwe[k]) else
     begin
      if ch='O' then { dodatkowy odstp midzy literami }
      begin
       cg4:='';
       for k:=1 to 3 do { koniecznie 3 cyfry !!! }
       begin
	read(plikwe,ch);
	cg4:=cg4+ch;
       end;
       val(cg4,k,l);
       if l=0 then
       begin
	piszcg(odstep); { Esc ' ' }
	write(plikwy,char(k)); { nn }
       end;
      end else if ch='C' then
      begin
       read(plikwe,ch);
       k:=pos(ch,litwy); { k<>0 => powrt z ktrej komendy }
       if k<>0 then piszcg(komwy[k]) else write(plikwy,'\C',ch);
{ jeli nie, to zapisz to, co byo }
      end else write(plikwy,'\',ch); { jw. }
     end;
    end;
   end;
  until eof(plikwe); { UFF ! }
 end;

 close(plikwe);
 close(plikwy);
end.
